#include "include.h"
#include "Power_Management.h"
/*#include "CAN_Communication_Matrix.h"
#include "Popup_Message_List.h"
#include "Common_Interface.h"
#include "Data_OilPressure.h"
#include "Data_Coolant.h"
#include "EOL_Para.h"
#include "Popup_Scheduler.h"
#include "Popup_List.h"
#include "Popups.h"
#include "Sound_Scheduler.h"
#include "Sound_List.h"
#include "Line_In_user.h"
#include "Line_in.h"
#include "SEG_DISPLAY.h"
 */

INT16U PopupAlarm;
_Popup_OnFlag_Struct Popup_OnFlag;
uint8_t Pop_DoorOpen_Flg = 0;

void Popups_IG_On_Init(void)
{
	// Popup_OnFlag.EPB_FltLevel = 1;
	// Popup_OnFlag.Fuel_SensorFlt = 1;
	// Popup_OnFlag.Fuel_Low = 1;
	// Popup_OnFlag.PDC_SysFlt = 1;
	// Popup_OnFlag.Maint_Distance = 1;
	// Popup_OnFlag.Maint_Car = 1;
	// Popup_OnFlag.AirPressLow_F = 1;
	// Popup_OnFlag.AirPressLow_R = 1;
	Pop_DoorOpen_Flg = 0;

	Popup_OnFlag.start_button = 1;
	Popup_OnFlag.nokey_sys_fault = 1;
	Popup_OnFlag.relay_fault = 1;
	Popup_OnFlag.authentication_failure = 1;
	Popup_OnFlag.undetected_key = 1;
	Popup_OnFlag.key_not_Car = 1;
	Popup_OnFlag.Key_close_start = 1;
	Popup_OnFlag.brake_to_start = 1;
	Popup_OnFlag.N_gear_start = 1;
	Popup_OnFlag.N_gear_parking = 1;

	Popup_OnFlag.key_low_power = 1;
	Popup_OnFlag.motor_high = 1;
	// Popup_OnFlag.Fuel_sensor_failure    = 1;
	// Popup_OnFlag.engine_water_high      = 1;
	// Popup_OnFlag.please_add_fuel        = 1;
	Popup_OnFlag.Please_charge_power = 1;
	Popup_OnFlag.Electronic_parking_fault = 1;
	Popup_OnFlag.please_foot_brake = 1;
	Popup_OnFlag.low_pressure = 1;
	Popup_OnFlag.gear_fault = 1;

	Popup_OnFlag.please_Step_brake = 1;
	Popup_OnFlag.please_N_gear = 1;
	Popup_OnFlag.Please_draw_charging = 1;
	Popup_OnFlag.high_low_temp = 1;
	Popup_OnFlag.charging_parking_brake = 1;
	Popup_OnFlag.charge_complete = 1;
	Popup_OnFlag.charge_fault = 1;
	Popup_OnFlag.Face_Loss = 1;
	Popup_OnFlag.fatigue_driving = 1;
	Popup_OnFlag.fatigue_driving_stopcar = 1;

	Popup_OnFlag.safe_driving = 1;
	Popup_OnFlag.Speeding_alarm = 1;
	Popup_OnFlag.Front_camera_occlusion = 1;
	Popup_OnFlag.SOC_low = 1;
	Popup_OnFlag.pressure_fault_stopfuel = 1;
	Popup_OnFlag.airbag_fault = 1;
	// Popup_OnFlag.TPMS_not_study       = 1;
	// Popup_OnFlag.TPMS_sensor_loss     = 1;
	// Popup_OnFlag.TPMS_sensor_fault    = 1;
	// Popup_OnFlag.TPMS_low             = 1;

	// Popup_OnFlag.TPMS_high              = 1;
	// Popup_OnFlag.tire_depresses_quickly = 1;
	// Popup_OnFlag.tire_temp_high         = 1;
	// Popup_OnFlag.TPMS_sensor_low_power  = 1;
	Popup_OnFlag.GPF = 1;
	Popup_OnFlag.Radar_sys_fault = 1;
	Popup_OnFlag.shifter_fault = 1;
	Popup_OnFlag.HighBeam_relay_fault = 1;
	Popup_OnFlag.RearFog_fault = 1;
	Popup_OnFlag.FrontFog_fault = 1;

	Popup_OnFlag.DayRun_fault = 1;
	Popup_OnFlag.Position_fault = 1;
	Popup_OnFlag.LowBeam_fault = 1;
	Popup_OnFlag.reversing_light_fault = 1;
	Popup_OnFlag.brake_light_fault = 1;
	Popup_OnFlag.Please_pull_key = 1;
	Popup_OnFlag.Maintenance_Km = 1;
	Popup_OnFlag.Maintenance_Tips = 1;
	// Popup_OnFlag.please_Maintenance_engine = 1;
	// Popup_OnFlag.Maintenance_engine_Km = 1;

	Popup_OnFlag.battery_low_power = 1;

	// Popup_OnFlag.GPF = 1;
	Popup_OnFlag.TPMS_NotLearnt_LF = 1;
	Popup_OnFlag.TPMS_NotLearnt_LR = 1;
	Popup_OnFlag.TPMS_NotLearnt_LIR = 1;
	Popup_OnFlag.TPMS_NotLearnt_RF = 1;
	Popup_OnFlag.TPMS_NotLearnt_RR = 1;
	Popup_OnFlag.TPMS_NotLearnt_RIR = 1;

	// Popup_OnFlag.GPF = 1;
	Popup_OnFlag.TPMS_SenLost_LF = 1;
	Popup_OnFlag.TPMS_SenLost_LR = 1;
	Popup_OnFlag.TPMS_SenLost_LIR = 1;
	Popup_OnFlag.TPMS_SenLost_RF = 1;
	Popup_OnFlag.TPMS_SenLost_RR = 1;
	Popup_OnFlag.TPMS_SenLost_RIR = 1;

	// Popup_OnFlag.GPF = 1;
	Popup_OnFlag.TPMS_SenFlt_LF = 1;
	Popup_OnFlag.TPMS_SenFlt_LR = 1;
	Popup_OnFlag.TPMS_SenFlt_LIR = 1;
	Popup_OnFlag.TPMS_SenFlt_RF = 1;
	Popup_OnFlag.TPMS_SenFlt_RR = 1;
	Popup_OnFlag.TPMS_SenFlt_RIR = 1;

	// Popup_OnFlag.GPF = 1;
	Popup_OnFlag.TPMS_TirePr_Low_LF = 1;
	Popup_OnFlag.TPMS_TirePr_Low_LR = 1;
	Popup_OnFlag.TPMS_TirePr_Low_LIR = 1;
	Popup_OnFlag.TPMS_TirePr_Low_RF = 1;
	Popup_OnFlag.TPMS_TirePr_Low_RR = 1;
	Popup_OnFlag.TPMS_TirePr_Low_RIR = 1;

	// Popup_OnFlag.GPF = 1;
	Popup_OnFlag.TPMS_TirePr_High_LF = 1;
	Popup_OnFlag.TPMS_TirePr_High_LR = 1;
	Popup_OnFlag.TPMS_TirePr_High_LIR = 1;
	Popup_OnFlag.TPMS_TirePr_High_RF = 1;
	Popup_OnFlag.TPMS_TirePr_High_RR = 1;
	Popup_OnFlag.TPMS_TirePr_High_RIR = 1;

	// Popup_OnFlag.GPF = 1;
	Popup_OnFlag.TPMS_FastLeak_LF = 1;
	Popup_OnFlag.TPMS_FastLeak_LR = 1;
	Popup_OnFlag.TPMS_FastLeak_LIR = 1;
	Popup_OnFlag.TPMS_FastLeak_RF = 1;
	Popup_OnFlag.TPMS_FastLeak_RR = 1;
	Popup_OnFlag.TPMS_FastLeak_RIR = 1;

	// Popup_OnFlag.GPF = 1;
	Popup_OnFlag.TPMS_Temp_High_LF = 1;
	Popup_OnFlag.TPMS_Temp_High_LR = 1;
	Popup_OnFlag.TPMS_Temp_High_LIR = 1;
	Popup_OnFlag.TPMS_Temp_High_RF = 1;
	Popup_OnFlag.TPMS_Temp_High_RR = 1;
	Popup_OnFlag.TPMS_Temp_High_RIR = 1;

	// Popup_OnFlag.GPF = 1;
	Popup_OnFlag.TPMS_BatLow_LF = 1;
	Popup_OnFlag.TPMS_BatLow_LR = 1;
	Popup_OnFlag.TPMS_BatLow_LIR = 1;
	Popup_OnFlag.TPMS_BatLow_RF = 1;
	Popup_OnFlag.TPMS_BatLow_RR = 1;
	Popup_OnFlag.TPMS_BatLow_RIR = 1;
}

void Popups_DoorOpen(void)
{
	if (SYS_OPR_STAT_IGN_ON)
	{
		if ((PageInfo.u16SelfCheckTimeCnt < SelfCheckTime) /*|| (Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 1)*/)
		{
			Pop_DoorOpen_Flg = 0;
			Popup_Clear(POPUP_ID_DoorOpen_Greate);
			Popup_Clear(POPUP_ID_DoorOpen_LF);
			Popup_Clear(POPUP_ID_DoorOpen_RF);
			Popup_Clear(POPUP_ID_DoorOpen_LR);
			Popup_Clear(POPUP_ID_DoorOpen_off_RR);
			Popup_Clear(POPUP_ID_DoorOpen_off_LF);
			Popup_Clear(POPUP_ID_DoorOpen_off_RF);
			Popup_Clear(POPUP_ID_DoorOpen_off_LR);
			Popup_Clear(POPUP_ID_DoorOpen_off_RR);
		}
		else
		{
			if ((DoorOpen.u8LF_St) || (DoorOpen.u8RF_St) || (DoorOpen.u8LR_St) || (DoorOpen.u8RR_St))
			{
				if (DataVSpeedDisp > 100)
				{
					Popup_Request(POPUP_ID_DoorOpen_Greate);
					Pop_DoorOpen_Flg = 1;
				}
				else if (DataVSpeedDisp <= 70)
				{
					Pop_DoorOpen_Flg = 0;
					Popup_Clear(POPUP_ID_DoorOpen_Greate);
					if (DoorOpen.u8LF_St == 1)
					{
						Popup_Request(POPUP_ID_DoorOpen_LF);
					}
					else
					{
						Popup_Clear(POPUP_ID_DoorOpen_LF);
					}
					if (DoorOpen.u8RF_St == 1)
					{
						Popup_Request(POPUP_ID_DoorOpen_RF);
					}
					else
					{
						Popup_Clear(POPUP_ID_DoorOpen_RF);
					}
					if (DoorOpen.u8LR_St == 1)
					{
						Popup_Request(POPUP_ID_DoorOpen_LR);
					}
					else
					{
						Popup_Clear(POPUP_ID_DoorOpen_LR);
					}
					if (DoorOpen.u8RR_St == 1)
					{
						Popup_Request(POPUP_ID_DoorOpen_RR);
					}
					else
					{
						Popup_Clear(POPUP_ID_DoorOpen_RR);
					}
				}
				else
				{
					if (Pop_DoorOpen_Flg == 1)
					{
					}
					else
					{
						Popup_Clear(POPUP_ID_DoorOpen_Greate);
						if (DoorOpen.u8LF_St == 1)
						{
							Popup_Request(POPUP_ID_DoorOpen_LF);
						}
						else
						{
							Popup_Clear(POPUP_ID_DoorOpen_LF);
						}
						if (DoorOpen.u8RF_St == 1)
						{
							Popup_Request(POPUP_ID_DoorOpen_RF);
						}
						else
						{
							Popup_Clear(POPUP_ID_DoorOpen_RF);
						}
						if (DoorOpen.u8LR_St == 1)
						{
							Popup_Request(POPUP_ID_DoorOpen_LR);
						}
						else
						{
							Popup_Clear(POPUP_ID_DoorOpen_LR);
						}
						if (DoorOpen.u8RR_St == 1)
						{
							Popup_Request(POPUP_ID_DoorOpen_RR);
						}
						else
						{
							Popup_Clear(POPUP_ID_DoorOpen_RR);
						}
					}
				}
			}
			else
			{
				Popup_Clear(POPUP_ID_DoorOpen_Greate);
				Popup_Clear(POPUP_ID_DoorOpen_LF);
				Popup_Clear(POPUP_ID_DoorOpen_RF);
				Popup_Clear(POPUP_ID_DoorOpen_LR);
				Popup_Clear(POPUP_ID_DoorOpen_RR);
			}
		}
	}
	else
	{
		Popup_Clear(POPUP_ID_DoorOpen_Greate);
		Popup_Clear(POPUP_ID_DoorOpen_LF);
		Popup_Clear(POPUP_ID_DoorOpen_RF);
		Popup_Clear(POPUP_ID_DoorOpen_LR);
		Popup_Clear(POPUP_ID_DoorOpen_RR);
		if (DoorOpen.u16OffTimer < 300)
		{
			if (DoorOpen.u8LF_St == 1)
			{
				Popup_Request(POPUP_ID_DoorOpen_off_LF);
			}
			else
			{
				Popup_Clear(POPUP_ID_DoorOpen_off_LF);
			}
			if (DoorOpen.u8RF_St == 1)
			{
				Popup_Request(POPUP_ID_DoorOpen_off_RF);
			}
			else
			{
				Popup_Clear(POPUP_ID_DoorOpen_off_RF);
			}
			if (DoorOpen.u8LR_St == 1)
			{
				Popup_Request(POPUP_ID_DoorOpen_off_LR);
			}
			else
			{
				Popup_Clear(POPUP_ID_DoorOpen_off_LR);
			}
			if (DoorOpen.u8RR_St == 1)
			{
				Popup_Request(POPUP_ID_DoorOpen_off_RR);
			}
			else
			{
				Popup_Clear(POPUP_ID_DoorOpen_off_RR);
			}
		}
		else
		{
			Popup_Clear(POPUP_ID_DoorOpen_off_LF);
			Popup_Clear(POPUP_ID_DoorOpen_off_RF);
			Popup_Clear(POPUP_ID_DoorOpen_off_LR);
			Popup_Clear(POPUP_ID_DoorOpen_off_RR);
		}
	}
}

void Popups_ChargeStatus(void)
{
	if (SYS_OPR_STAT_IGN_ON)
	{
		if ((PageInfo.u16SelfCheckTimeCnt < SelfCheckTime) /*|| (Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 1)*/)
		{
			Popup_Clear(POPUP_ID_charge_display);
			Popup_Clear(POPUP_ID_charge_display_off);
		}
		else
		{
			if (ChargeStatus.u8Chg_St)
			{
				Popup_Request(POPUP_ID_charge_display);
			}
			else
			{
				Popup_Delete(POPUP_ID_charge_display);
			}
		}
	}
	else
	{
		Popup_Clear(POPUP_ID_charge_display);
		if (ChargeStatus.u8Flag == 1)
		{
			if (ChargeStatus.u16OffTimer_Door < 3000)
			{
				if (ChargeStatus.u8Chg_St)
				{
					Popup_Request(POPUP_ID_charge_display_off);
				}
				else
				{
					Popup_Clear(POPUP_ID_charge_display_off);
				}
			}
			else
			{
				Popup_Clear(POPUP_ID_charge_display_off);
			}
		}
		else if (ChargeStatus.u8Flag == 2)
		{
			if (ChargeStatus.u16OffTimer < 300)
			{
				if (ChargeStatus.u8Chg_St)
				{
					Popup_Request(POPUP_ID_charge_display_off);
				}
				else
				{
					Popup_Clear(POPUP_ID_charge_display_off);
				}
			}
			else
			{
				Popup_Clear(POPUP_ID_charge_display_off);
			}
		}
		else
		{
			Popup_Clear(POPUP_ID_charge_display_off);
		}
	}
}

void Popups_Polling(void)
{
	uint16_t PopupMsg = 0xFFFFu;
	uint8_t PopupSnd = 0xFFu;

	if (SYS_OPR_STAT_HALT)
	{
		return;
	}

	if (Bus_Sleep_Mode_Delay_Time >= BusSleep_Wait_Mode_Time)
	{

		Popup_Clear(POPUP_ID_Leave_the_vehicle);
		//Popup_Clear(POPUP_ID_Please_wait_relieving_pressure);
		Popup_Clear(POPUP_ID_Little_light);
		Popup_Clear(POPUP_ID_start_button);
		Popup_Clear(POPUP_ID_nokey_sys_fault);
		Popup_Clear(POPUP_ID_authentication_failure);
		Popup_Clear(POPUP_ID_undetected_key);
		Popup_Clear(POPUP_ID_Key_close_start);
		Popup_Clear(POPUP_ID_brake_to_start);
		Popup_Clear(POPUP_ID_N_gear_start);
		Popup_Clear(POPUP_ID_N_gear_parking);
		Popup_Clear(POPUP_ID_key_low_power);
		Popup_Clear(POPUP_ID_charging_parking_brake);
		Popup_Clear(POPUP_ID_charge_complete);
		Popup_Clear(POPUP_ID_charge_fault);
		Popup_Clear(POPUP_ID_Please_pull_key);
		Popup_Clear(POPUP_ID_charge_display_off);
		// Popup_Clear(POPUP_ID_cooling_liquid_low);
		Popup_Clear(POPUP_ID_DoorOpen_off);
		Popup_Clear(POPUP_ID_DoorOpen_off_LF);
		Popup_Clear(POPUP_ID_DoorOpen_off_RF);
		Popup_Clear(POPUP_ID_DoorOpen_off_LR);
		Popup_Clear(POPUP_ID_DoorOpen_off_RR);

		return;
	}

	if ((SYS_OPR_STAT_IGN_ON) && (PageInfo.u16SelfCheckTimeCnt >= SelfCheckTime) && (Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 0))
	{
		///////////////////////////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////////
		///////////����1/////////////////////////////////////////////////////////////////////////

		// OTA
		// ������
		if (Get_CAN_CH0_ID_18FAB027_Sig_PMS_VehicleSlipWarning() == 1)
		{
			Popup_Request(POPUP_ID_Skid_of_vehicle);
		}
		else
		{
			Popup_Delete(POPUP_ID_Skid_of_vehicle);
		}

		// �복����ǿ��
		if ((Get_CAN_CH0_ID_18FAB027_Sig_PMS_PTReadyInd() == 1) && (Get_CAN_CH0_ID_18FDA521_Sig_BCM_FrontLeftDoorAjarStatus() == 1))
		{
			Popup_Request(POPUP_ID_Close_30);
		}
		else
		{
			Popup_Delete(POPUP_ID_Close_30);
		}

		// ���עȼ��(Ԥ��)

		// �������س���
		if (Get_CAN_CH0_ID_18FAAE27_Sig_PMS_OverloadInd() == 2)
		{
			Popup_Request(POPUP_ID_Heavy_overload);
		}
		else
		{
			Popup_Delete(POPUP_ID_Heavy_overload);
		}
		// ��������
		if (Get_CAN_CH0_ID_18FAAE27_Sig_PMS_OverloadInd() == 1)
		{
			Popup_Request(POPUP_ID_Overload);
		}
		else
		{
			Popup_Delete(POPUP_ID_Overload);
		}

		// ǰ������վ����
		if (Val_EOL_F110_EMS() == 1)
		{
#if 0 // without can
			if (Get_CAN_CH0_ID_18FA92D0_Sig_EMS_GPFRegenerationInd() == 2)
			{
				Popup_Request(POPUP_ID_Go_to_service_station);
			}
			else
			{
				Popup_Delete(POPUP_ID_Go_to_service_station);
			}
#endif
		}
		else
		{
			//Popup_Delete(POPUP_ID_Go_to_service_station);
		}

		// ����������ʧ��,�����޷���������
		if (Val_EOL_F110_EGSM() == 1)
		{
#if 1 // without can
			if (Get_CAN_CH0_ID_0C012705_Sig_EGSM_LockStatus() == 5)
			{
				Popup_Request(POPUP_ID_Vehicle_not_shift_gears);
			}
			else
			{
				Popup_Delete(POPUP_ID_Vehicle_not_shift_gears);
			}
#endif
		}
		else
		{
			Popup_Delete(POPUP_ID_Vehicle_not_shift_gears);
		}

		// ����������������,�������������
		if (Val_EOL_F110_EGSM() == 1)
		{
#if 1 // without can
			if (Get_CAN_CH0_ID_0C012705_Sig_EGSM_LockStatus() == 2)
			{
				Popup_Request(POPUP_ID_Do_not_operate_shift_gears);
			}
			else
			{
				Popup_Delete(POPUP_ID_Do_not_operate_shift_gears);
			}
#endif
		}
		else
		{
			Popup_Delete(POPUP_ID_Do_not_operate_shift_gears);
		}
		// ��ϵ�ð�ȫ�����ֶ��ͷ�פ��
		if (Val_EOL_F110_EPB_Liquid() == 1)
		{
#if 1 // without can
			if (Get_CAN_CH0_ID_0CFABF8F_Sig_EPB_SafeBeltNotTiedLmtReleaseWarning() == 1)
			{
				Popup_Request(POPUP_ID_SafetyBelt_EPB);
			}
			else
			{
				Popup_Delete(POPUP_ID_SafetyBelt_EPB);
			}
#endif
		}
		else if (Val_EOL_F110_EPB_Air() == 1)
		{
			if (Get_CAN_CH0_ID_18FFB88F_Sig_EPB_SafeBeltNotTiedLmtReleaseWarning() == 1)
			{
				Popup_Request(POPUP_ID_SafetyBelt_EPB);
			}
			else
			{
				Popup_Delete(POPUP_ID_SafetyBelt_EPB);
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_SafetyBelt_EPB);
		}
		///////////����2/////////////////////////////////////////////////////////////////////////
		// �̵�������
		if (Val_EOL_F110_PEPS() == 1)
		{
#if 1 // without can
			if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_IGN1FailureWarning() == 1)
			{
				if (Popup_OnFlag.relay_fault)
				{
					Popup_Request(POPUP_ID_relay_fault);
					Popup_OnFlag.relay_fault = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_relay_fault);
			}
#endif
		}
		else
		{
			Popup_Delete(POPUP_ID_relay_fault);
		}

		// ����Կ�ײ��ڳ�
		if (Val_EOL_F110_PEPS() == 1)
		{
#if 1 // without can
			if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_Warning_Keyout() == 1)
			{
				if (Popup_OnFlag.key_not_Car)
				{
					Popup_Request(POPUP_ID_key_not_Car);
					Popup_OnFlag.key_not_Car = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_key_not_Car);
			}
#endif
		}
		else
		{
			Popup_Delete(POPUP_ID_key_not_Car);
		}

		// �������,��������
		if (Get_CAN_CH0_ID_18FA02EF_Sig_MCU_MotorTempHighAlarm() == 1)
		{
			if (Popup_OnFlag.motor_high)
			{
				Popup_Request(POPUP_ID_motor_high);
				Popup_OnFlag.motor_high = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_motor_high);
		}
		// ȼ�ʹ�����ʧ��(Ԥ��)
		// ������ˮ�¸�(Ԥ��)
		// �벹��ȼ��(Ԥ��)

		// ���������뼰ʱ���
		if (Get_CAN_CH0_ID_18FA42F4_Sig_BMS_BattSOCFault() == 1)
		{
			if (Popup_OnFlag.Please_charge_power)
			{
				Popup_Request(POPUP_ID_Please_charge_power);
				Popup_OnFlag.Please_charge_power = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_Please_charge_power);
		}

		// ����פ������
		if (Val_EOL_F110_EPB_Liquid() == 1)
		{
#if 1 // without can
			if (Get_CAN_CH0_ID_0CFABF8F_Sig_EPB_WarningLampState() == 1)
			{
				if (Popup_OnFlag.Electronic_parking_fault)
				{
					Popup_Request(POPUP_ID_Electronic_parking_fault);
					Popup_OnFlag.Electronic_parking_fault = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_Electronic_parking_fault);
			}
#endif
		}
		else if (Val_EOL_F110_EPB_Air() == 1)
		{
			if ((Get_CAN_CH0_ID_18FFB88F_Sig_EPB_FltLevel() == 1) || (Get_CAN_CH0_ID_18FFB88F_Sig_EPB_FltLevel() == 2) || (Get_CAN_CH0_ID_18FFB88F_Sig_EPB_FltLevel() == 3))
			{
				if (Popup_OnFlag.Electronic_parking_fault)
				{
					Popup_Request(POPUP_ID_Electronic_parking_fault);
					Popup_OnFlag.Electronic_parking_fault = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_Electronic_parking_fault);
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_Electronic_parking_fault);
		}

		// ���ס��ɲ,���ͷ�פ��
		if (Get_CAN_CH0_ID_18FFB88F_Sig_EPB_ChildLockActive() == 1)
		{
			if (Popup_OnFlag.please_foot_brake)
			{
				Popup_Request(POPUP_ID_please_foot_brake);
				Popup_OnFlag.please_foot_brake = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_please_foot_brake);
		}

		// ��ѹ����,��ֹ�ͷ�פ��
		if (Get_CAN_CH0_ID_18FFB88F_Sig_EPB_LowPreReleaseParkLimit() == 1)
		{
			if (Popup_OnFlag.low_pressure)
			{
				Popup_Request(POPUP_ID_low_pressure);
				Popup_OnFlag.low_pressure = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_low_pressure);
		}

		// ��������,����ƶ�̤�廻��
		if (Get_CAN_CH0_ID_18FAB027_Sig_PMS_GearOperateErr() == 1)
		{
			if (Popup_OnFlag.gear_fault)
			{
				Popup_Request(POPUP_ID_gear_fault);
				Popup_OnFlag.gear_fault = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_gear_fault);
		}

		// ����ƶ�̤��
		if (Get_CAN_CH0_ID_0CFAB127_Sig_PMS_DriverOperationReminder() == 2)
		{
			if (Popup_OnFlag.please_Step_brake)
			{
				Popup_Request(POPUP_ID_please_Step_brake);
				Popup_OnFlag.please_Step_brake = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_please_Step_brake);
		}

		// ���N��
		if (Get_CAN_CH0_ID_0CFAB127_Sig_PMS_DriverOperationReminder() == 1)
		{
			if (Popup_OnFlag.please_N_gear)
			{
				Popup_Request(POPUP_ID_please_N_gear);
				Popup_OnFlag.please_N_gear = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_please_N_gear);
		}

		// ��γ��ǹ
		if (Get_CAN_CH0_ID_0CFAB127_Sig_PMS_DriverOperationReminder() == 4)
		{
			if (Popup_OnFlag.Please_draw_charging)
			{
				Popup_Request(POPUP_ID_Please_draw_charging);
				Popup_OnFlag.Please_draw_charging = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_Please_draw_charging);
		}

		// �ߵ���,������������
		if (Get_CAN_CH0_ID_0CFAB127_Sig_PMS_DriverOperationReminder() == 5)
		{
			if (Popup_OnFlag.high_low_temp)
			{
				Popup_Request(POPUP_ID_high_low_temp);
				Popup_OnFlag.high_low_temp = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_high_low_temp);
		}

#if 1 // without can
		// ����ͼ��ʧ
		if (Val_EOL_F110_DMM() == 1)
		{
			if (Get_CAN_CH0_ID_18FAD084_Sig_DMM_Occlusion_Alarm() == 1)
			{
				if (Popup_OnFlag.Face_Loss)
				{
					Popup_Request(POPUP_ID_Face_Loss);
					Popup_OnFlag.Face_Loss = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_Face_Loss);
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_Face_Loss);
		}

		// ƣ�ͼ�ʻ
		if (Val_EOL_F110_DMM() == 1)
		{
			if (Get_CAN_CH0_ID_18FAD084_Sig_DMM_Fatigue_Warning_Status() == 1)
			{
				if (Popup_OnFlag.fatigue_driving)
				{
					Popup_Request(POPUP_ID_fatigue_driving);
					Popup_OnFlag.fatigue_driving = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_fatigue_driving);
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_fatigue_driving);
		}

		// ƣ�ͼ�ʻ,ͣ����Ϣ
		if (Val_EOL_F110_DMM() == 1)
		{
			if (Get_CAN_CH0_ID_18FAD084_Sig_DMM_Fatigue_Warning_Status() == 2)
			{
				if (Popup_OnFlag.fatigue_driving_stopcar)
				{
					Popup_Request(POPUP_ID_fatigue_driving_stopcar);
					Popup_OnFlag.fatigue_driving_stopcar = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_fatigue_driving_stopcar);
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_fatigue_driving_stopcar);
		}

		// ��ȫ��ʻ
		if (Val_EOL_F110_DMM() == 1)
		{
			if (Get_CAN_CH0_ID_18FAD084_Sig_DMM_UnsafeAct_Warning_Status() == 1)
			{
				if (Popup_OnFlag.safe_driving)
				{
					Popup_Request(POPUP_ID_safe_driving);
					Popup_OnFlag.safe_driving = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_safe_driving);
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_safe_driving);
		}
#endif

		// ���ٱ���
		if (Menu_Item_Select_Get(MENU_ITEM_SET_OVERSPEED_OPEN) == 1u)
		{
			if (DataVSpeedValid)
			{
				if ((DataVSpeedDisp / 10) > DataOverSpeed)
				{
					if (Popup_OnFlag.Speeding_alarm)
					{
						Popup_Request(POPUP_ID_Speeding_alarm);
						Popup_OnFlag.Speeding_alarm = 0;
					}
				}
				else if ((DataVSpeedDisp / 10) < (DataOverSpeed - 2))
				{
					Popup_Delete(POPUP_ID_Speeding_alarm);
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_Speeding_alarm);
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_Speeding_alarm);
		}

		// ǰ������ͷ�ڵ�
		if (Val_EOL_F110_FCS() == 1)
		{
#if 0 // without can
			if (Get_CAN_CH0_ID_18FE5BE8_Sig_FCS_LDWCameraStatus() == 3)
			{
				if (Popup_OnFlag.Front_camera_occlusion)
				{
					Popup_Request(POPUP_ID_Front_camera_occlusion);
					Popup_OnFlag.Front_camera_occlusion = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_Front_camera_occlusion);
			}
#endif
		}
		else
		{
			//Popup_Delete(POPUP_ID_Front_camera_occlusion);
		}

		// SOC̫��
		if (Get_CAN_CH0_ID_0CFAB127_Sig_PMS_DriverOperationReminder() == 3)
		{
			if (Popup_OnFlag.SOC_low)
			{
				Popup_Request(POPUP_ID_SOC_low);
				Popup_OnFlag.SOC_low = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_SOC_low);
		}

		// йѹ������,��ֹ����
		if ((Val_EOL_F110_EMS() == 1) && (Val_EOL_F101_EmissionsStandards() == 2))
		{
#if 0 // without can
			if (Get_CAN_CH0_ID_18FA92D0_Sig_EMS_FTIVFault() == 1)
			{
				if (Popup_OnFlag.pressure_fault_stopfuel)
				{
					Popup_Request(POPUP_ID_pressure_fault_stopfuel);
					Popup_OnFlag.pressure_fault_stopfuel = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_pressure_fault_stopfuel);
			}
#endif
		}
		else
		{
			//Popup_Delete(POPUP_ID_pressure_fault_stopfuel);
		}

		// ��ȫ���ҹ���
		if (Val_EOL_F110_ACU() == 1)
		{
			if (Val_EOL_F101_CollisionSystem() == 1)
			{
#if 1 // without can
				if (Get_CAN_CH0_ID_18FAC490_Sig_ACU_AirbagWarningStatus() == 1)
				{
					if (Popup_OnFlag.airbag_fault)
					{
						Popup_Request(POPUP_ID_airbag_fault);
						Popup_OnFlag.airbag_fault = 0;
					}
				}
				else
				{
					Popup_Delete(POPUP_ID_airbag_fault);
				}
#endif
			}
			else if (Val_EOL_F101_CollisionSystem() == 2)
			{
#if 1 // without can
				if (Get_CAN_CH0_ID_18FAC490_Sig_ACU_AirbagWarningStatus() == 1)
				{
					if (Popup_OnFlag.airbag_fault)
					{
						Popup_Request(POPUP_ID_airbag_fault);
						Popup_OnFlag.airbag_fault = 0;
					}
				}
				else
				{
					Popup_Delete(POPUP_ID_airbag_fault);
				}
#endif
			}
			else
			{
				Popup_Delete(POPUP_ID_airbag_fault);
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_airbag_fault);
		}

		// ̥ѹδѧϰ
		// ̥ѹ��������ʧ
		// ̥ѹ����������
		// ̥ѹ�ͱ���
		// ̥ѹ�߱���
		// ��̥����йѹ����
		// ̥�¸߱���
		// ̥ѹ�����������ͱ���

		// GPF������
		if (Val_EOL_F110_EMS() == 1)
		{
#if 1 // without can
			if (Get_CAN_CH0_ID_18FA92D0_Sig_EMS_GPFRegenerationInd() == 1)
			{
				if (Popup_OnFlag.GPF)
				{
					Popup_Request(POPUP_ID_GPF);
					Popup_OnFlag.GPF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_GPF);
			}
#endif
		}
		else
		{
			Popup_Delete(POPUP_ID_GPF);
		}

		// �״�ϵͳ����
		if (Val_EOL_F110_PDC() == 1)
		{
			if (Get_CAN_CH0_ID_0CFF1ADA_Sig_PDC_SystemState() == 1)
			{
				if (Popup_OnFlag.Radar_sys_fault)
				{
					Popup_Request(POPUP_ID_Radar_sys_fault);
					Popup_OnFlag.Radar_sys_fault = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_Radar_sys_fault);
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_Radar_sys_fault);
		}
		// ��ȫ��
		if (g_stSafeBelt.u8Pop_Warn == 1)
		{
			Popup_Request(POPUP_ID_SafetyBelt);
		}
		else
		{
			Popup_Delete(POPUP_ID_SafetyBelt);
		}

		// ����������
		if (Val_EOL_F110_EGSM() == 1)
		{
#if 1 // without can
			if (Get_CAN_CH0_ID_0C012705_Sig_EGSM_WorkStatus() == 1)
			{
				if (Popup_OnFlag.shifter_fault)
				{
					Popup_Request(POPUP_ID_shifter_fault);
					Popup_OnFlag.shifter_fault = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_shifter_fault);
			}
#endif
		}
		else
		{
			Popup_Delete(POPUP_ID_shifter_fault);
		}

		// Զ��Ƽ̵�������
		if (Get_CAN_CH0_ID_18FE4021_Sig_BCM_HighBeamHeadLightData() == 2)
		{
			if (Popup_OnFlag.HighBeam_relay_fault)
			{
				Popup_Request(POPUP_ID_HighBeam_relay_fault);
				Popup_OnFlag.HighBeam_relay_fault = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_HighBeam_relay_fault);
		}
		// ������
		if (Get_CAN_CH0_ID_18FE4021_Sig_BCM_RearFogLights() == 2)
		{
			if (Popup_OnFlag.RearFog_fault)
			{
				Popup_Request(POPUP_ID_RearFog_fault);
				Popup_OnFlag.RearFog_fault = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_RearFog_fault);
		}

		// ǰ����
		if (Get_CAN_CH0_ID_18FE4021_Sig_BCM_TractorFrontFogLights() == 2)
		{
			if (Popup_OnFlag.FrontFog_fault)
			{
				Popup_Request(POPUP_ID_FrontFog_fault);
				Popup_OnFlag.FrontFog_fault = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_FrontFog_fault);
		}

		// ���е�
		if (Get_CAN_CH0_ID_18FE4021_Sig_BCM_RunningLight() == 2)
		{
			if (Popup_OnFlag.DayRun_fault)
			{
				Popup_Request(POPUP_ID_DayRun_fault);
				Popup_OnFlag.DayRun_fault = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_DayRun_fault);
		}

		// λ�õ�
		if (Get_CAN_CH0_ID_18FE4021_Sig_BCM_TractorMarkerLight() == 2)
		{
			if (Popup_OnFlag.Position_fault)
			{
				Popup_Request(POPUP_ID_Position_fault);
				Popup_OnFlag.Position_fault = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_Position_fault);
		}

		// �����
		if (Get_CAN_CH0_ID_18FE4021_Sig_BCM_LowBeamHeadLightData() == 2)
		{
			if (Popup_OnFlag.LowBeam_fault)
			{
				Popup_Request(POPUP_ID_LowBeam_fault);
				Popup_OnFlag.LowBeam_fault = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_LowBeam_fault);
		}

		// ������
		if (Get_CAN_CH0_ID_18FE4021_Sig_BCM_BackUpLightAndAlarmHorn() == 2)
		{
			if (Popup_OnFlag.reversing_light_fault)
			{
				Popup_Request(POPUP_ID_reversing_light_fault);
				Popup_OnFlag.reversing_light_fault = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_reversing_light_fault);
		}

		// �ƶ���
		if (Get_CAN_CH0_ID_18FE4021_Sig_BCM_LeftStopLight() == 2)
		{
			if (Popup_OnFlag.brake_light_fault)
			{
				Popup_Request(POPUP_ID_brake_light_fault);
				Popup_OnFlag.brake_light_fault = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_brake_light_fault);
		}

		// ����������ʾ
		if (Val_EOL_F101_ServiceMaintain() == 2)
		{
			if (Menu_Item_Select_Get(MENU_ITEM_SET_MAINT_OPEN) == 1u)
			{
				// �ౣ������---km
				if (DataServiceDistanceWarning == 1)
				{
					if (Popup_OnFlag.Maintenance_Km)
					{
						Popup_Request(POPUP_ID_Maintenance_Km);
						Popup_OnFlag.Maintenance_Km = 0;
					}
				}
				else
				{
					Popup_Delete(POPUP_ID_Maintenance_Km);
				}
				// ��������������
				if (DataServiceWarning == 1)
				{
					if (Popup_OnFlag.Maintenance_Tips)
					{
						Popup_Request(POPUP_ID_Maintenance_Tips);
						Popup_OnFlag.Maintenance_Tips = 0;
					}
				}
				else
				{
					Popup_Delete(POPUP_ID_Maintenance_Tips);
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_Maintenance_Km);
				Popup_Delete(POPUP_ID_Maintenance_Tips);
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_Maintenance_Km);
			Popup_Delete(POPUP_ID_Maintenance_Tips);
		}

		/*// ����������������
		if(Val_EOL_F110_EMS() == 1)
		{
			if (Val_EOL_F101_ServiceMaintain() == 2)
			{
				if (DE_PMS_EngMaintanceFlag == 1)
				{
					if (Popup_OnFlag.please_Maintenance_engine)
					{
						Popup_Request(POPUP_ID_please_Maintenance_engine);
						Popup_OnFlag.please_Maintenance_engine = 0;
					}
				}
				else
				{
					Popup_Delete(POPUP_ID_please_Maintenance_engine);
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_please_Maintenance_engine);
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_please_Maintenance_engine);
		}

		// ���뷢������������Km
		if(Val_EOL_F110_EMS() == 1)
		{
			if (Val_EOL_F101_ServiceMaintain() == 2)
			{
				if (DE_PMS_EngMaintainWarningSts == 1)
				{
					if (Popup_OnFlag.Maintenance_engine_Km)
					{
						Popup_Request(POPUP_ID_Maintenance_engine_Km);
						Popup_OnFlag.Maintenance_engine_Km = 0;
					}
				}
				else
				{
					Popup_Delete(POPUP_ID_Maintenance_engine_Km);
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_Maintenance_engine_Km);
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_Maintenance_engine_Km);
		}*/

		// ���ص�����
		if (Val_EOL_F110_TBOX() == 1)
		{
			if (Get_CAN_CH0_ID_18FF629F_Sig_TBOX_BatteryVoltageLowWarning() == 1)
			{
				if (Popup_OnFlag.battery_low_power)
				{
					Popup_Request(POPUP_ID_battery_low_power);
					Popup_OnFlag.battery_low_power = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_battery_low_power);
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_battery_low_power);
		}

		// ȡ��������(Ԥ��)
		// ȡ����������R��(Ԥ��)
		///////////����3/////////////////////////////////////////////////////////////////////////
		// �г���Ϣ,�˵�������ʾ

		///////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////
		// ̥ѹ8��
		if ((TPMS_Config.F110 == 1) && (TPMS_Config.F101 == 1))
		{
			// ̥ѹδѧϰ
			if (Left_Front_Display.System_Flt == 3)
			{
				if (Popup_OnFlag.TPMS_NotLearnt_LF)
				{
					Popup_Request(POPUP_ID_TPMS_NotLearnt_LF);
					Popup_OnFlag.TPMS_NotLearnt_LF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_NotLearnt_LF);
			}
			if (Left_Rear_Display.System_Flt == 3)
			{
				if (Popup_OnFlag.TPMS_NotLearnt_LR)
				{
					Popup_Request(POPUP_ID_TPMS_NotLearnt_LR);
					Popup_OnFlag.TPMS_NotLearnt_LR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_NotLearnt_LR);
			}
			if (Left_Rear_Inside_Display.System_Flt == 3)
			{
				if (Popup_OnFlag.TPMS_NotLearnt_LIR)
				{
					Popup_Request(POPUP_ID_TPMS_NotLearnt_LIR);
					Popup_OnFlag.TPMS_NotLearnt_LIR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_NotLearnt_LIR);
			}
			if (Right_Front_Display.System_Flt == 3)
			{
				if (Popup_OnFlag.TPMS_NotLearnt_RF)
				{
					Popup_Request(POPUP_ID_TPMS_NotLearnt_RF);
					Popup_OnFlag.TPMS_NotLearnt_RF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_NotLearnt_RF);
			}
			if (Right_Rear_Display.System_Flt == 3)
			{
				if (Popup_OnFlag.TPMS_NotLearnt_RR)
				{
					Popup_Request(POPUP_ID_TPMS_NotLearnt_RR);
					Popup_OnFlag.TPMS_NotLearnt_RR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_NotLearnt_RR);
			}
			if (Right_Rear_Inside_Display.System_Flt == 3)
			{
				if (Popup_OnFlag.TPMS_NotLearnt_RIR)
				{
					Popup_Request(POPUP_ID_TPMS_NotLearnt_RIR);
					Popup_OnFlag.TPMS_NotLearnt_RIR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_NotLearnt_RIR);
			}

			// ��������ʧ
			if (Left_Front_Display.Sensor_Loss == 1)
			{
				if (Popup_OnFlag.TPMS_SenLost_LF)
				{
					Popup_Request(POPUP_ID_TPMS_SenLost_LF);
					Popup_OnFlag.TPMS_SenLost_LF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenLost_LF);
			}
			if (Left_Rear_Display.Sensor_Loss == 1)
			{
				if (Popup_OnFlag.TPMS_SenLost_LR)
				{
					Popup_Request(POPUP_ID_TPMS_SenLost_LR);
					Popup_OnFlag.TPMS_SenLost_LR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenLost_LR);
			}
			if (Left_Rear_Inside_Display.Sensor_Loss == 1)
			{
				if (Popup_OnFlag.TPMS_SenLost_LIR)
				{
					Popup_Request(POPUP_ID_TPMS_SenLost_LIR);
					Popup_OnFlag.TPMS_SenLost_LIR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenLost_LIR);
			}
			if (Right_Front_Display.Sensor_Loss == 1)
			{
				if (Popup_OnFlag.TPMS_SenLost_RF)
				{
					Popup_Request(POPUP_ID_TPMS_SenLost_RF);
					Popup_OnFlag.TPMS_SenLost_RF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenLost_RF);
			}
			if (Right_Rear_Display.Sensor_Loss == 1)
			{
				if (Popup_OnFlag.TPMS_SenLost_RR)
				{
					Popup_Request(POPUP_ID_TPMS_SenLost_RR);
					Popup_OnFlag.TPMS_SenLost_RR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenLost_RR);
			}
			if (Right_Rear_Inside_Display.Sensor_Loss == 1)
			{
				if (Popup_OnFlag.TPMS_SenLost_RIR)
				{
					Popup_Request(POPUP_ID_TPMS_SenLost_RIR);
					Popup_OnFlag.TPMS_SenLost_RIR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenLost_RIR);
			}

			// ����������
			if (Left_Front_Display.Sensor_Flt == 1)
			{
				if (Popup_OnFlag.TPMS_SenFlt_LF)
				{
					Popup_Request(POPUP_ID_TPMS_SenFlt_LF);
					Popup_OnFlag.TPMS_SenFlt_LF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenFlt_LF);
			}
			if (Left_Rear_Display.Sensor_Flt == 1)
			{
				if (Popup_OnFlag.TPMS_SenFlt_LR)
				{
					Popup_Request(POPUP_ID_TPMS_SenFlt_LR);
					Popup_OnFlag.TPMS_SenFlt_LR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenFlt_LR);
			}
			if (Left_Rear_Inside_Display.Sensor_Flt == 1)
			{
				if (Popup_OnFlag.TPMS_SenFlt_LIR)
				{
					Popup_Request(POPUP_ID_TPMS_SenFlt_LIR);
					Popup_OnFlag.TPMS_SenFlt_LIR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenFlt_LIR);
			}
			if (Right_Front_Display.Sensor_Flt == 1)
			{
				if (Popup_OnFlag.TPMS_SenFlt_RF)
				{
					Popup_Request(POPUP_ID_TPMS_SenFlt_RF);
					Popup_OnFlag.TPMS_SenFlt_RF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenFlt_RF);
			}
			if (Right_Rear_Display.Sensor_Flt == 1)
			{
				if (Popup_OnFlag.TPMS_SenFlt_RR)
				{
					Popup_Request(POPUP_ID_TPMS_SenFlt_RR);
					Popup_OnFlag.TPMS_SenFlt_RR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenFlt_RR);
			}
			if (Right_Rear_Inside_Display.Sensor_Flt == 1)
			{
				if (Popup_OnFlag.TPMS_SenFlt_RIR)
				{
					Popup_Request(POPUP_ID_TPMS_SenFlt_RIR);
					Popup_OnFlag.TPMS_SenFlt_RIR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenFlt_RIR);
			}
			// ̥ѹ�ͣ�̥ѹ��
			if (Left_Front_Display.Press_St == 1)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_LF);
				if (Popup_OnFlag.TPMS_TirePr_Low_LF)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_Low_LF);
					Popup_OnFlag.TPMS_TirePr_Low_LF = 0;
				}
			}
			else if (Left_Front_Display.Press_St == 2)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_LF);
				if (Popup_OnFlag.TPMS_TirePr_High_LF)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_High_LF);
					Popup_OnFlag.TPMS_TirePr_High_LF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_LF);
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_LF);
			}
			if (Left_Rear_Display.Press_St == 1)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_LR);
				if (Popup_OnFlag.TPMS_TirePr_Low_LR)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_Low_LR);
					Popup_OnFlag.TPMS_TirePr_Low_LR = 0;
				}
			}
			else if (Left_Rear_Display.Press_St == 2)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_LR);
				if (Popup_OnFlag.TPMS_TirePr_High_LR)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_High_LR);
					Popup_OnFlag.TPMS_TirePr_High_LR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_LR);
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_LR);
			}

			if (Left_Rear_Inside_Display.Press_St == 1)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_LIR);
				if (Popup_OnFlag.TPMS_TirePr_Low_LIR)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_Low_LIR);
					Popup_OnFlag.TPMS_TirePr_Low_LIR = 0;
				}
			}
			else if (Left_Rear_Inside_Display.Press_St == 2)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_LIR);
				if (Popup_OnFlag.TPMS_TirePr_High_LIR)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_High_LIR);
					Popup_OnFlag.TPMS_TirePr_High_LIR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_LIR);
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_LIR);
			}

			if (Right_Front_Display.Press_St == 1)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_RF);
				if (Popup_OnFlag.TPMS_TirePr_Low_RF)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_Low_RF);
					Popup_OnFlag.TPMS_TirePr_Low_RF = 0;
				}
			}
			else if (Right_Front_Display.Press_St == 2)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_RF);
				if (Popup_OnFlag.TPMS_TirePr_High_RF)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_High_RF);
					Popup_OnFlag.TPMS_TirePr_High_RF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_RF);
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_RF);
			}

			if (Right_Rear_Display.Press_St == 1)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_RR);
				if (Popup_OnFlag.TPMS_TirePr_Low_RR)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_Low_RR);
					Popup_OnFlag.TPMS_TirePr_Low_RR = 0;
				}
			}
			else if (Right_Rear_Display.Press_St == 2)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_RR);
				if (Popup_OnFlag.TPMS_TirePr_High_RR)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_High_RR);
					Popup_OnFlag.TPMS_TirePr_High_RR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_RR);
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_RR);
			}

			if (Right_Rear_Inside_Display.Press_St == 1)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_RIR);
				if (Popup_OnFlag.TPMS_TirePr_Low_RIR)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_Low_RIR);
					Popup_OnFlag.TPMS_TirePr_Low_RIR = 0;
				}
			}
			else if (Right_Rear_Inside_Display.Press_St == 2)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_RIR);
				if (Popup_OnFlag.TPMS_TirePr_High_RIR)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_High_RIR);
					Popup_OnFlag.TPMS_TirePr_High_RIR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_RIR);
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_RIR);
			}

			// ����йѹ
			if (Left_Front_Display.Fast_Press == 1)
			{
				if (Popup_OnFlag.TPMS_FastLeak_LF)
				{
					Popup_Request(POPUP_ID_TPMS_FastLeak_LF);
					Popup_OnFlag.TPMS_FastLeak_LF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_FastLeak_LF);
			}
			if (Left_Rear_Display.Fast_Press == 1)
			{
				if (Popup_OnFlag.TPMS_FastLeak_LR)
				{
					Popup_Request(POPUP_ID_TPMS_FastLeak_LR);
					Popup_OnFlag.TPMS_FastLeak_LR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_FastLeak_LR);
			}
			if (Left_Rear_Inside_Display.Fast_Press == 1)
			{
				if (Popup_OnFlag.TPMS_FastLeak_LIR)
				{
					Popup_Request(POPUP_ID_TPMS_FastLeak_LIR);
					Popup_OnFlag.TPMS_FastLeak_LIR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_FastLeak_LIR);
			}
			if (Right_Front_Display.Fast_Press == 1)
			{
				if (Popup_OnFlag.TPMS_FastLeak_RF)
				{
					Popup_Request(POPUP_ID_TPMS_FastLeak_RF);
					Popup_OnFlag.TPMS_FastLeak_RF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_FastLeak_RF);
			}
			if (Right_Rear_Display.Fast_Press == 1)
			{
				if (Popup_OnFlag.TPMS_FastLeak_RR)
				{
					Popup_Request(POPUP_ID_TPMS_FastLeak_RR);
					Popup_OnFlag.TPMS_FastLeak_RR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_FastLeak_RR);
			}
			if (Right_Rear_Inside_Display.Fast_Press == 1)
			{
				if (Popup_OnFlag.TPMS_FastLeak_RIR)
				{
					Popup_Request(POPUP_ID_TPMS_FastLeak_RIR);
					Popup_OnFlag.TPMS_FastLeak_RIR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_FastLeak_RIR);
			}
			// ̥ѹ�¶ȸ�
			if (Left_Front_Display.Temp_St == 1)
			{
				if (Popup_OnFlag.TPMS_Temp_High_LF)
				{
					Popup_Request(POPUP_ID_TPMS_Temp_High_LF);
					Popup_OnFlag.TPMS_Temp_High_LF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_Temp_High_LF);
			}
			if (Left_Rear_Display.Temp_St == 1)
			{
				if (Popup_OnFlag.TPMS_Temp_High_LR)
				{
					Popup_Request(POPUP_ID_TPMS_Temp_High_LR);
					Popup_OnFlag.TPMS_Temp_High_LR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_Temp_High_LR);
			}
			if (Left_Rear_Inside_Display.Temp_St == 1)
			{
				if (Popup_OnFlag.TPMS_Temp_High_LIR)
				{
					Popup_Request(POPUP_ID_TPMS_Temp_High_LIR);
					Popup_OnFlag.TPMS_Temp_High_LIR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_Temp_High_LIR);
			}
			if (Right_Front_Display.Temp_St == 1)
			{
				if (Popup_OnFlag.TPMS_Temp_High_RF)
				{
					Popup_Request(POPUP_ID_TPMS_Temp_High_RF);
					Popup_OnFlag.TPMS_Temp_High_RF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_Temp_High_RF);
			}
			if (Right_Rear_Display.Temp_St == 1)
			{
				if (Popup_OnFlag.TPMS_Temp_High_RR)
				{
					Popup_Request(POPUP_ID_TPMS_Temp_High_RR);
					Popup_OnFlag.TPMS_Temp_High_RR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_Temp_High_RR);
			}
			if (Right_Rear_Inside_Display.Temp_St == 1)
			{
				if (Popup_OnFlag.TPMS_Temp_High_RIR)
				{
					Popup_Request(POPUP_ID_TPMS_Temp_High_RIR);
					Popup_OnFlag.TPMS_Temp_High_RIR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_Temp_High_RIR);
			}

			// ̥ѹ�¶ȸ�
			if (Left_Front_Display.BatLow_St == 1)
			{
				if (Popup_OnFlag.TPMS_BatLow_LF)
				{
					Popup_Request(POPUP_ID_TPMS_BatLow_LF);
					Popup_OnFlag.TPMS_BatLow_LF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_BatLow_LF);
			}
			if (Left_Rear_Display.BatLow_St == 1)
			{
				if (Popup_OnFlag.TPMS_BatLow_LR)
				{
					Popup_Request(POPUP_ID_TPMS_BatLow_LR);
					Popup_OnFlag.TPMS_BatLow_LR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_BatLow_LR);
			}
			if (Left_Rear_Inside_Display.BatLow_St == 1)
			{
				if (Popup_OnFlag.TPMS_BatLow_LIR)
				{
					Popup_Request(POPUP_ID_TPMS_BatLow_LIR);
					Popup_OnFlag.TPMS_BatLow_LIR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_BatLow_LIR);
			}
			if (Right_Front_Display.BatLow_St == 1)
			{
				if (Popup_OnFlag.TPMS_BatLow_RF)
				{
					Popup_Request(POPUP_ID_TPMS_BatLow_RF);
					Popup_OnFlag.TPMS_BatLow_RF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_BatLow_RF);
			}
			if (Right_Rear_Display.BatLow_St == 1)
			{
				if (Popup_OnFlag.TPMS_BatLow_RR)
				{
					Popup_Request(POPUP_ID_TPMS_BatLow_RR);
					Popup_OnFlag.TPMS_BatLow_RR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_BatLow_RR);
			}
			if (Right_Rear_Inside_Display.BatLow_St == 1)
			{
				if (Popup_OnFlag.TPMS_BatLow_RIR)
				{
					Popup_Request(POPUP_ID_TPMS_BatLow_RIR);
					Popup_OnFlag.TPMS_BatLow_RIR = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_BatLow_RIR);
			}
		}
		else if ((TPMS_Config.F110 == 1) && (TPMS_Config.F101 == 2))
		{
			// ̥ѹδѧϰ
			if (Left_Front_Display.System_Flt == 3)
			{
				if (Popup_OnFlag.TPMS_NotLearnt_LF)
				{
					Popup_Request(POPUP_ID_TPMS_NotLearnt_LF);
					Popup_OnFlag.TPMS_NotLearnt_LF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_NotLearnt_LF);
			}

			if (Right_Front_Display.System_Flt == 3)
			{
				if (Popup_OnFlag.TPMS_NotLearnt_RF)
				{
					Popup_Request(POPUP_ID_TPMS_NotLearnt_RF);
					Popup_OnFlag.TPMS_NotLearnt_RF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_NotLearnt_RF);
			}

			// ��������ʧ
			if (Left_Front_Display.Sensor_Loss == 1)
			{
				if (Popup_OnFlag.TPMS_SenLost_LF)
				{
					Popup_Request(POPUP_ID_TPMS_SenLost_LF);
					Popup_OnFlag.TPMS_SenLost_LF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenLost_LF);
			}

			if (Right_Front_Display.Sensor_Loss == 1)
			{
				if (Popup_OnFlag.TPMS_SenLost_RF)
				{
					Popup_Request(POPUP_ID_TPMS_SenLost_RF);
					Popup_OnFlag.TPMS_SenLost_RF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenLost_RF);
			}

			// ����������
			if (Left_Front_Display.Sensor_Flt == 1)
			{
				if (Popup_OnFlag.TPMS_SenFlt_LF)
				{
					Popup_Request(POPUP_ID_TPMS_SenFlt_LF);
					Popup_OnFlag.TPMS_SenFlt_LF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenFlt_LF);
			}

			if (Right_Front_Display.Sensor_Flt == 1)
			{
				if (Popup_OnFlag.TPMS_SenFlt_RF)
				{
					Popup_Request(POPUP_ID_TPMS_SenFlt_RF);
					Popup_OnFlag.TPMS_SenFlt_RF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_SenFlt_RF);
			}

			// ̥ѹ�ͣ�̥ѹ��
			if (Left_Front_Display.Press_St == 1)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_LF);
				if (Popup_OnFlag.TPMS_TirePr_Low_LF)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_Low_LF);
					Popup_OnFlag.TPMS_TirePr_Low_LF = 0;
				}
			}
			else if (Left_Front_Display.Press_St == 2)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_LF);
				if (Popup_OnFlag.TPMS_TirePr_High_LF)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_High_LF);
					Popup_OnFlag.TPMS_TirePr_High_LF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_LF);
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_LF);
			}

			if (Right_Front_Display.Press_St == 1)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_RF);
				if (Popup_OnFlag.TPMS_TirePr_Low_RF)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_Low_RF);
					Popup_OnFlag.TPMS_TirePr_Low_RF = 0;
				}
			}
			else if (Right_Front_Display.Press_St == 2)
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_RF);
				if (Popup_OnFlag.TPMS_TirePr_High_RF)
				{
					Popup_Request(POPUP_ID_TPMS_TirePr_High_RF);
					Popup_OnFlag.TPMS_TirePr_High_RF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_TirePr_Low_RF);
				Popup_Delete(POPUP_ID_TPMS_TirePr_High_RF);
			}

			// ����йѹ
			if (Left_Front_Display.Fast_Press == 1)
			{
				if (Popup_OnFlag.TPMS_FastLeak_LF)
				{
					Popup_Request(POPUP_ID_TPMS_FastLeak_LF);
					Popup_OnFlag.TPMS_FastLeak_LF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_FastLeak_LF);
			}

			if (Right_Front_Display.Fast_Press == 1)
			{
				if (Popup_OnFlag.TPMS_FastLeak_RF)
				{
					Popup_Request(POPUP_ID_TPMS_FastLeak_RF);
					Popup_OnFlag.TPMS_FastLeak_RF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_FastLeak_RF);
			}

			// ̥ѹ�¶ȸ�
			if (Left_Front_Display.Temp_St == 1)
			{
				if (Popup_OnFlag.TPMS_Temp_High_LF)
				{
					Popup_Request(POPUP_ID_TPMS_Temp_High_LF);
					Popup_OnFlag.TPMS_Temp_High_LF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_Temp_High_LF);
			}

			if (Right_Front_Display.Temp_St == 1)
			{
				if (Popup_OnFlag.TPMS_Temp_High_RF)
				{
					Popup_Request(POPUP_ID_TPMS_Temp_High_RF);
					Popup_OnFlag.TPMS_Temp_High_RF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_Temp_High_RF);
			}

			// ̥ѹ�¶ȸ�
			if (Left_Front_Display.BatLow_St == 1)
			{
				if (Popup_OnFlag.TPMS_BatLow_LF)
				{
					Popup_Request(POPUP_ID_TPMS_BatLow_LF);
					Popup_OnFlag.TPMS_BatLow_LF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_BatLow_LF);
			}

			if (Right_Front_Display.BatLow_St == 1)
			{
				if (Popup_OnFlag.TPMS_BatLow_RF)
				{
					Popup_Request(POPUP_ID_TPMS_BatLow_RF);
					Popup_OnFlag.TPMS_BatLow_RF = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_TPMS_BatLow_RF);
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_TPMS_NotLearnt_RIR);
			Popup_Delete(POPUP_ID_TPMS_NotLearnt_RR);
			Popup_Delete(POPUP_ID_TPMS_NotLearnt_RF);
			Popup_Delete(POPUP_ID_TPMS_NotLearnt_LIR);
			Popup_Delete(POPUP_ID_TPMS_NotLearnt_LF);
			Popup_Delete(POPUP_ID_TPMS_NotLearnt_LR);

			Popup_Delete(POPUP_ID_TPMS_SenLost_RIR);
			Popup_Delete(POPUP_ID_TPMS_SenLost_RR);
			Popup_Delete(POPUP_ID_TPMS_SenLost_RF);
			Popup_Delete(POPUP_ID_TPMS_SenLost_LIR);
			Popup_Delete(POPUP_ID_TPMS_SenLost_LF);
			Popup_Delete(POPUP_ID_TPMS_SenLost_LR);

			Popup_Delete(POPUP_ID_TPMS_SenFlt_RIR);
			Popup_Delete(POPUP_ID_TPMS_SenFlt_RR);
			Popup_Delete(POPUP_ID_TPMS_SenFlt_RF);
			Popup_Delete(POPUP_ID_TPMS_SenFlt_LIR);
			Popup_Delete(POPUP_ID_TPMS_SenFlt_LF);
			Popup_Delete(POPUP_ID_TPMS_SenFlt_LR);

			Popup_Delete(POPUP_ID_TPMS_TirePr_Low_RIR);
			Popup_Delete(POPUP_ID_TPMS_TirePr_Low_RR);
			Popup_Delete(POPUP_ID_TPMS_TirePr_Low_RF);
			Popup_Delete(POPUP_ID_TPMS_TirePr_Low_LIR);
			Popup_Delete(POPUP_ID_TPMS_TirePr_Low_LF);
			Popup_Delete(POPUP_ID_TPMS_TirePr_Low_LR);

			Popup_Delete(POPUP_ID_TPMS_TirePr_High_RIR);
			Popup_Delete(POPUP_ID_TPMS_TirePr_High_RR);
			Popup_Delete(POPUP_ID_TPMS_TirePr_High_RF);
			Popup_Delete(POPUP_ID_TPMS_TirePr_High_LIR);
			Popup_Delete(POPUP_ID_TPMS_TirePr_High_LF);
			Popup_Delete(POPUP_ID_TPMS_TirePr_High_LR);

			Popup_Delete(POPUP_ID_TPMS_FastLeak_RIR);
			Popup_Delete(POPUP_ID_TPMS_FastLeak_RR);
			Popup_Delete(POPUP_ID_TPMS_FastLeak_RF);
			Popup_Delete(POPUP_ID_TPMS_FastLeak_LIR);
			Popup_Delete(POPUP_ID_TPMS_FastLeak_LF);
			Popup_Delete(POPUP_ID_TPMS_FastLeak_LR);

			Popup_Delete(POPUP_ID_TPMS_Temp_High_RIR);
			Popup_Delete(POPUP_ID_TPMS_Temp_High_RR);
			Popup_Delete(POPUP_ID_TPMS_Temp_High_RF);
			Popup_Delete(POPUP_ID_TPMS_Temp_High_LIR);
			Popup_Delete(POPUP_ID_TPMS_Temp_High_LF);
			Popup_Delete(POPUP_ID_TPMS_Temp_High_LR);

			Popup_Delete(POPUP_ID_TPMS_BatLow_RIR);
			Popup_Delete(POPUP_ID_TPMS_BatLow_RR);
			Popup_Delete(POPUP_ID_TPMS_BatLow_RF);
			Popup_Delete(POPUP_ID_TPMS_BatLow_LIR);
			Popup_Delete(POPUP_ID_TPMS_BatLow_LF);
			Popup_Delete(POPUP_ID_TPMS_BatLow_LR);
		}
	}
	else
	{
		Popup_Clear(POPUP_ID_TPMS_NotLearnt_RIR);
		Popup_Clear(POPUP_ID_TPMS_NotLearnt_RR);
		Popup_Clear(POPUP_ID_TPMS_NotLearnt_RF);
		Popup_Clear(POPUP_ID_TPMS_NotLearnt_LIR);
		Popup_Clear(POPUP_ID_TPMS_NotLearnt_LF);
		Popup_Clear(POPUP_ID_TPMS_NotLearnt_LR);

		Popup_Clear(POPUP_ID_TPMS_SenLost_RIR);
		Popup_Clear(POPUP_ID_TPMS_SenLost_RR);
		Popup_Clear(POPUP_ID_TPMS_SenLost_RF);
		Popup_Clear(POPUP_ID_TPMS_SenLost_LIR);
		Popup_Clear(POPUP_ID_TPMS_SenLost_LF);
		Popup_Clear(POPUP_ID_TPMS_SenLost_LR);

		Popup_Clear(POPUP_ID_TPMS_SenFlt_RIR);
		Popup_Clear(POPUP_ID_TPMS_SenFlt_RR);
		Popup_Clear(POPUP_ID_TPMS_SenFlt_RF);
		Popup_Clear(POPUP_ID_TPMS_SenFlt_LIR);
		Popup_Clear(POPUP_ID_TPMS_SenFlt_LF);
		Popup_Clear(POPUP_ID_TPMS_SenFlt_LR);

		Popup_Clear(POPUP_ID_TPMS_TirePr_Low_RIR);
		Popup_Clear(POPUP_ID_TPMS_TirePr_Low_RR);
		Popup_Clear(POPUP_ID_TPMS_TirePr_Low_RF);
		Popup_Clear(POPUP_ID_TPMS_TirePr_Low_LIR);
		Popup_Clear(POPUP_ID_TPMS_TirePr_Low_LF);
		Popup_Clear(POPUP_ID_TPMS_TirePr_Low_LR);

		Popup_Clear(POPUP_ID_TPMS_TirePr_High_RIR);
		Popup_Clear(POPUP_ID_TPMS_TirePr_High_RR);
		Popup_Clear(POPUP_ID_TPMS_TirePr_High_RF);
		Popup_Clear(POPUP_ID_TPMS_TirePr_High_LIR);
		Popup_Clear(POPUP_ID_TPMS_TirePr_High_LF);
		Popup_Clear(POPUP_ID_TPMS_TirePr_High_LR);

		Popup_Clear(POPUP_ID_TPMS_FastLeak_RIR);
		Popup_Clear(POPUP_ID_TPMS_FastLeak_RR);
		Popup_Clear(POPUP_ID_TPMS_FastLeak_RF);
		Popup_Clear(POPUP_ID_TPMS_FastLeak_LIR);
		Popup_Clear(POPUP_ID_TPMS_FastLeak_LF);
		Popup_Clear(POPUP_ID_TPMS_FastLeak_LR);

		Popup_Clear(POPUP_ID_TPMS_Temp_High_RIR);
		Popup_Clear(POPUP_ID_TPMS_Temp_High_RR);
		Popup_Clear(POPUP_ID_TPMS_Temp_High_RF);
		Popup_Clear(POPUP_ID_TPMS_Temp_High_LIR);
		Popup_Clear(POPUP_ID_TPMS_Temp_High_LF);
		Popup_Clear(POPUP_ID_TPMS_Temp_High_LR);

		Popup_Clear(POPUP_ID_TPMS_BatLow_RIR);
		Popup_Clear(POPUP_ID_TPMS_BatLow_RR);
		Popup_Clear(POPUP_ID_TPMS_BatLow_RF);
		Popup_Clear(POPUP_ID_TPMS_BatLow_LIR);
		Popup_Clear(POPUP_ID_TPMS_BatLow_LF);
		Popup_Clear(POPUP_ID_TPMS_BatLow_LR);

		//////1��_sh/////////////////////////////////////////////////////
		// Popup_Clear(POPUP_ID_Leave_the_vehicle              );
		// Popup_Clear(POPUP_ID_OTA);
		Popup_Clear(POPUP_ID_Skid_of_vehicle);
		// Popup_Clear(POPUP_MSG_DoorOpen_Greate                   );
		//Popup_Clear(POPUP_ID_Radar);
		Popup_Clear(POPUP_ID_SafetyBelt);
		Popup_Clear(POPUP_ID_Close_30);
		// Popup_Clear(POPUP_ID_Please_wait_relieving_pressure );
		// Popup_Clear(POPUP_ID_Please_Fuel_up                 );
		Popup_Clear(POPUP_ID_Heavy_overload);
		Popup_Clear(POPUP_ID_Overload);
		// Popup_Clear(POPUP_ID_Little_light                    );
		//Popup_Clear(POPUP_ID_Go_to_service_station);
		Popup_Clear(POPUP_ID_Vehicle_not_shift_gears);
		Popup_Clear(POPUP_ID_Do_not_operate_shift_gears);
		Popup_Clear(POPUP_ID_SafetyBelt_EPB);
		//////2��_sh/////////////////////////////////////////////////////
		// Popup_Clear(	POPUP_ID_start_button           	);
		// Popup_Clear(	POPUP_ID_nokey_sys_fault        	);
		Popup_Clear(POPUP_ID_relay_fault);
		// Popup_Clear(	POPUP_ID_authentication_failure 	);
		// Popup_Clear(	POPUP_ID_undetected_key         	);
		Popup_Clear(POPUP_ID_key_not_Car);
		// Popup_Clear(	POPUP_ID_Key_close_start        	);
		// Popup_Clear(	POPUP_ID_brake_to_start         	);
		// Popup_Clear(	POPUP_ID_N_gear_start           	);
		// Popup_Clear(	POPUP_ID_N_gear_parking         	);

		// Popup_Clear(	//POPUP_ID_key_low_power,          	);
		Popup_Clear(POPUP_ID_motor_high);
		// Popup_Clear(	POPUP_ID_Fuel_sensor_failure,    	);
		// Popup_Clear(	POPUP_ID_engine_water_high,      	);
		// Popup_Clear(	POPUP_ID_please_add_fuel,        	);
		Popup_Clear(POPUP_ID_Please_charge_power);
		Popup_Clear(POPUP_ID_Electronic_parking_fault);
		Popup_Clear(POPUP_ID_please_foot_brake);
		Popup_Clear(POPUP_ID_low_pressure);
		Popup_Clear(POPUP_ID_gear_fault);

		Popup_Clear(POPUP_ID_please_Step_brake);
		Popup_Clear(POPUP_ID_please_N_gear);
		Popup_Clear(POPUP_ID_Please_draw_charging);
		Popup_Clear(POPUP_ID_high_low_temp);
		// Popup_Clear(	POPUP_ID_charging_parking_brake   	);
		// Popup_Clear(	POPUP_ID_charge_complete          	);
		// Popup_Clear(	POPUP_ID_charge_fault             	);
		Popup_Clear(POPUP_ID_Face_Loss);
		Popup_Clear(POPUP_ID_fatigue_driving);
		Popup_Clear(POPUP_ID_fatigue_driving_stopcar);

		Popup_Clear(POPUP_ID_safe_driving);
		Popup_Clear(POPUP_ID_Speeding_alarm);
		//Popup_Clear(POPUP_ID_Front_camera_occlusion);
		Popup_Clear(POPUP_ID_SOC_low);
		//Popup_Clear(POPUP_ID_pressure_fault_stopfuel);
		Popup_Clear(POPUP_ID_airbag_fault);
		// Popup_Clear(	POPUP_ID_TPMS_not_study         	);
		// Popup_Clear(	POPUP_ID_TPMS_sensor_loss       	);
		// Popup_Clear(	POPUP_ID_TPMS_sensor_fault      	);
		// Popup_Clear(	POPUP_ID_TPMS_low               	);

		// Popup_Clear(	POPUP_ID_TPMS_high             	);
		// Popup_Clear(	POPUP_ID_tire_depresses_quickly 	);
		// Popup_Clear(	POPUP_ID_tire_temp_high        	);
		// Popup_Clear(	POPUP_ID_TPMS_sensor_low_power 	);
		Popup_Clear(POPUP_ID_GPF);
		Popup_Clear(POPUP_ID_Radar_sys_fault);
		Popup_Clear(POPUP_ID_shifter_fault);
		Popup_Clear(POPUP_ID_HighBeam_relay_fault);
		Popup_Clear(POPUP_ID_RearFog_fault);
		Popup_Clear(POPUP_ID_FrontFog_fault);

		Popup_Clear(POPUP_ID_DayRun_fault);
		Popup_Clear(POPUP_ID_Position_fault);
		Popup_Clear(POPUP_ID_LowBeam_fault);
		Popup_Clear(POPUP_ID_reversing_light_fault);
		Popup_Clear(POPUP_ID_brake_light_fault);
		// Popup_Clear(	POPUP_ID_Please_pull_key          	);
		Popup_Clear(POPUP_ID_Maintenance_Km);
		Popup_Clear(POPUP_ID_Maintenance_Tips);
		// Popup_Clear(POPUP_ID_please_Maintenance_engine);
		// Popup_Clear(POPUP_ID_Maintenance_engine_Km);
		Popup_Clear(POPUP_ID_battery_low_power);

		// Popup_Clear(	POPUP_ID_power_takeoff_fault 	);
		// Popup_Clear(	POPUP_ID_power_takeoff_R_gear 	);
		//////3��_sh/////////////////////////////////////////////////////
		// Popup_Clear(	POPUP_ID_Driving_information	);
		// Popup_Clear(	POPUP_ID_charge_display    	);
		// Popup_Clear(	POPUP_ID_cooling_liquid_low	);
	}

	// IGOFF
	if (!SYS_OPR_STAT_IGN_ON)
	{
		// С��δ��
		if ((Get_CAN_CH0_ID_18FE4021_Sig_BCM_LightLeftOn() == 1) && (Get_CAN_CH0_ID_18FDA521_Sig_BCM_FrontLeftDoorAjarStatus() == 1))
		{
			Popup_Request(POPUP_ID_Little_light);
		}
		else
		{
			Popup_Delete(POPUP_ID_Little_light);
		}

		// ���Կ��
		if (Get_CAN_CH0_ID_18FFDD21_Sig_BCM_KeyInwithDrvDoorAjar() == 1)
		{
			if (Popup_OnFlag.Please_pull_key)
			{
				Popup_Request(POPUP_ID_Please_pull_key);
				Popup_OnFlag.Please_pull_key = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_Please_pull_key);
		}
	}
	else
	{
		Popup_Clear(POPUP_ID_Little_light);
		Popup_Clear(POPUP_ID_Please_pull_key);
	}

	// IGON_OFF
	Popups_DoorOpen();
	Popups_ChargeStatus();
	// �뾡���뿪����
	if(Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 0)
	{
		if (Get_CAN_CH0_ID_18FA41F4_Sig_BMS_TempOutofCtr() == 1)
		{
			Popup_Request(POPUP_ID_Leave_the_vehicle);
		}
		else
		{
			Popup_Delete(POPUP_ID_Leave_the_vehicle);
		}
	}
	else
	{
		Popup_Clear(POPUP_ID_Leave_the_vehicle);
	}

	// ���ʱ������ɲ
	if (SYS_OPR_STAT_IGN_ON)
	{
		if(Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 0)
		{
			if (PageInfo.u16SelfCheckTimeCnt < SelfCheckTime)
			{
				Popup_Delete(POPUP_ID_charging_parking_brake);
			}
			else
			{
				if (Get_CAN_CH0_ID_0CFAB127_Sig_PMS_DriverOperationReminder() == 6)
				{
					if (Popup_OnFlag.charging_parking_brake)
					{
						Popup_Request(POPUP_ID_charging_parking_brake);
						Popup_OnFlag.charging_parking_brake = 0;
					}
				}
				else
				{
					Popup_Delete(POPUP_ID_charging_parking_brake);
				}
			}
		}
		else
		{
			Popup_Clear(POPUP_ID_charging_parking_brake);
		}
	}
	else
	{
		if (Get_CAN_CH0_ID_0CFAB127_Sig_PMS_DriverOperationReminder() == 6)
		{
			if (Popup_OnFlag.charging_parking_brake)
			{
				Popup_Request(POPUP_ID_charging_parking_brake);
				Popup_OnFlag.charging_parking_brake = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_charging_parking_brake);
		}
	}

	// ������
	if (SYS_OPR_STAT_IGN_ON)
	{
		if(Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 0)
		{
			if (PageInfo.u16SelfCheckTimeCnt < SelfCheckTime)
			{
				Popup_Delete(POPUP_ID_charge_complete);
			}
			else
			{
				if ((Get_CAN_CH0_ID_18FA3EF4_Sig_BMS_ChgStatus() == 2) && (Get_CAN_CH0_ID_18FA3EF4_Sig_BMS_DCChgPlugSts() == 1))
				{
					if (Popup_OnFlag.charge_complete)
					{
						Popup_Request(POPUP_ID_charge_complete);
						Popup_OnFlag.charge_complete = 0;
					}
				}
				else
				{
					Popup_Delete(POPUP_ID_charge_complete);
				}
			}
		}
		else
		{
			Popup_Clear(POPUP_ID_charge_complete);
		}
	}
	else
	{
		if ((Get_CAN_CH0_ID_18FA3EF4_Sig_BMS_ChgStatus() == 2) && (Get_CAN_CH0_ID_18FA3EF4_Sig_BMS_DCChgPlugSts() == 1))
		{
			if (Popup_OnFlag.charge_complete)
			{
				Popup_Request(POPUP_ID_charge_complete);
				Popup_OnFlag.charge_complete = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_charge_complete);
		}
	}

	// ����쳣
	if (SYS_OPR_STAT_IGN_ON)
	{
		if(Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 0)
		{
			if (PageInfo.u16SelfCheckTimeCnt < SelfCheckTime)
			{
				Popup_Delete(POPUP_ID_charge_fault);
			}
			else
			{
				if (((Get_CAN_CH0_ID_18FA3EF4_Sig_BMS_ChgStatus() == 3) || (Get_CAN_CH0_ID_18FA3EF4_Sig_BMS_ChgStatus() == 6) || (Get_CAN_CH0_ID_18FA3EF4_Sig_BMS_ChgStatus() == 7)) && (Get_CAN_CH0_ID_18FA3EF4_Sig_BMS_DCChgPlugSts() == 1))
				{
					if (Popup_OnFlag.charge_fault)
					{
						Popup_Request(POPUP_ID_charge_fault);
						Popup_OnFlag.charge_fault = 0;
					}
				}
				else
				{
					Popup_Delete(POPUP_ID_charge_fault);
				}
			}
		}
		else
		{
			Popup_Clear(POPUP_ID_charge_fault);
		}
	}
	else
	{
		if (((Get_CAN_CH0_ID_18FA3EF4_Sig_BMS_ChgStatus() == 3) || (Get_CAN_CH0_ID_18FA3EF4_Sig_BMS_ChgStatus() == 6) || (Get_CAN_CH0_ID_18FA3EF4_Sig_BMS_ChgStatus() == 7)) && (Get_CAN_CH0_ID_18FA3EF4_Sig_BMS_DCChgPlugSts() == 1))
		{
			if (Popup_OnFlag.charge_fault)
			{
				Popup_Request(POPUP_ID_charge_fault);
				Popup_OnFlag.charge_fault = 0;
			}
		}
		else
		{
			Popup_Delete(POPUP_ID_charge_fault);
		}
	}

	// �����ʾ
	/*	if((DE_BMS_ChgStatus == 1)||(DE_BMS_ChgStatus == 4)||(DE_BMS_ChgStatus == 5))
		{
			Popup_Request(POPUP_ID_charge_display );
		}
		else
		{
			Popup_Delete(POPUP_ID_charge_display );
		}
		*/

	// йѹ����ȴ�
	if ((Val_EOL_F110_EMS() == 1) && (Val_EOL_F101_EmissionsStandards() == 2))
	{
#if 0 // without can
		if (Get_CAN_CH0_ID_18FA92D0_Sig_EMS_PresReliefReady() == 1)
		{
			Popup_Request(POPUP_ID_Please_wait_relieving_pressure);
		}
		else
		{
			Popup_Delete(POPUP_ID_Please_wait_relieving_pressure);
		}
#endif
	}
	else
	{
		//Popup_Delete(POPUP_ID_Please_wait_relieving_pressure);
	}

	// ������ť
	if (Val_EOL_F110_PEPS() == 1)
	{
		if (SYS_OPR_STAT_IGN_ON)
		{
			if(Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 0)
			{
				if (PageInfo.u16SelfCheckTimeCnt < SelfCheckTime)
				{
					Popup_Delete(POPUP_ID_start_button);
				}
				else
				{
					if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_SSB_Failure_warning() == 1)
					{
						if (Popup_OnFlag.start_button)
						{
							Popup_Request(POPUP_ID_start_button);
							Popup_OnFlag.start_button = 0;
						}
					}
					else
					{
						Popup_Delete(POPUP_ID_start_button);
					}
				}
			}
			else
			{
				Popup_Clear(POPUP_ID_start_button);
			}
		}
		else
		{
			if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_SSB_Failure_warning() == 1)
			{
				if (Popup_OnFlag.start_button)
				{
					Popup_Request(POPUP_ID_start_button);
					Popup_OnFlag.start_button = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_start_button);
			}
		}
	}
	else
	{
		Popup_Delete(POPUP_ID_start_button);
	}

	// ��Կ��ϵͳ����
	if (Val_EOL_F110_PEPS() == 1)
	{
		if (SYS_OPR_STAT_IGN_ON)
		{
			if(Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 0)
			{
				if (PageInfo.u16SelfCheckTimeCnt < SelfCheckTime)
				{
					Popup_Delete(POPUP_ID_nokey_sys_fault);
				}
				else
				{
					if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_SystemFault() == 1)
					{
						if (Popup_OnFlag.nokey_sys_fault)
						{
							Popup_Request(POPUP_ID_nokey_sys_fault);
							Popup_OnFlag.nokey_sys_fault = 0;
						}
					}
					else
					{
						Popup_Delete(POPUP_ID_nokey_sys_fault);
					}
				}
			}
			else
			{
				Popup_Clear(POPUP_ID_nokey_sys_fault);
			}
		}
		else
		{
			if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_SystemFault() == 1)
			{
				if (Popup_OnFlag.nokey_sys_fault)
				{
					Popup_Request(POPUP_ID_nokey_sys_fault);
					Popup_OnFlag.nokey_sys_fault = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_nokey_sys_fault);
			}
		}
	}
	else
	{
		Popup_Delete(POPUP_ID_nokey_sys_fault);
	}

	// ������֤ʧ��
	if (Val_EOL_F110_PEPS() == 1)
	{
		if (SYS_OPR_STAT_IGN_ON)
		{
			if(Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 0)
			{
				if (PageInfo.u16SelfCheckTimeCnt < SelfCheckTime)
				{
					Popup_Delete(POPUP_ID_authentication_failure);
				}
				else
				{
					if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_Warning_IMMO_Fail() == 1)
					{
						if (Popup_OnFlag.authentication_failure)
						{
							Popup_Request(POPUP_ID_authentication_failure);
							Popup_OnFlag.authentication_failure = 0;
						}
					}
					else
					{
						Popup_Delete(POPUP_ID_authentication_failure);
					}
				}
			}
			else
			{
				Popup_Clear(POPUP_ID_authentication_failure);
			}
		}
		else
		{
			if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_Warning_IMMO_Fail() == 1)
			{
				if (Popup_OnFlag.authentication_failure)
				{
					Popup_Request(POPUP_ID_authentication_failure);
					Popup_OnFlag.authentication_failure = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_authentication_failure);
			}
		}
	}
	else
	{
		Popup_Delete(POPUP_ID_authentication_failure);
	}

	// δ��⵽Կ��
	if (Val_EOL_F110_PEPS() == 1)
	{
		if (SYS_OPR_STAT_IGN_ON)
		{
			if(Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 0)
			{
				if (PageInfo.u16SelfCheckTimeCnt < SelfCheckTime)
				{
					Popup_Delete(POPUP_ID_undetected_key);
				}
				else
				{
					if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_Warning_No_key_found() == 1)
					{
						if (Popup_OnFlag.undetected_key)
						{
							Popup_Request(POPUP_ID_undetected_key);
							Popup_OnFlag.undetected_key = 0;
						}
					}
					else
					{
						Popup_Delete(POPUP_ID_undetected_key);
					}
				}
			}
			else
			{
				Popup_Clear(POPUP_ID_undetected_key);
			}
		}
		else
		{
			if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_Warning_No_key_found() == 1)
			{
				if (Popup_OnFlag.undetected_key)
				{
					Popup_Request(POPUP_ID_undetected_key);
					Popup_OnFlag.undetected_key = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_undetected_key);
			}
		}
	}
	else
	{
		Popup_Delete(POPUP_ID_undetected_key);
	}

	// Կ�׿���ָʾ������
	if (Val_EOL_F110_PEPS() == 1)
	{
		if (SYS_OPR_STAT_IGN_ON)
		{
			if(Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 0)
			{
				if (PageInfo.u16SelfCheckTimeCnt < SelfCheckTime)
				{
					Popup_Delete(POPUP_ID_Key_close_start);
				}
				else
				{
					if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_Indication_UID_Closer() == 1)
					{
						if (Popup_OnFlag.Key_close_start)
						{
							Popup_Request(POPUP_ID_Key_close_start);
							Popup_OnFlag.Key_close_start = 0;
						}
					}
					else
					{
						Popup_Delete(POPUP_ID_Key_close_start);
					}
				}
			}
			else
			{
				Popup_Clear(POPUP_ID_Key_close_start);
			}
		}
		else
		{
			if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_Indication_UID_Closer() == 1)
			{
				if (Popup_OnFlag.Key_close_start)
				{
					Popup_Request(POPUP_ID_Key_close_start);
					Popup_OnFlag.Key_close_start = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_Key_close_start);
			}
		}
	}
	else
	{
		Popup_Delete(POPUP_ID_Key_close_start);
	}

	// ���ɲ������
	if (Val_EOL_F110_PEPS() == 1)
	{
		if (SYS_OPR_STAT_IGN_ON)
		{
			if(Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 0)
			{
				if (PageInfo.u16SelfCheckTimeCnt < SelfCheckTime)
				{
					Popup_Delete(POPUP_ID_brake_to_start);
				}
				else
				{
					if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_Indication_press_brake_clutch() == 1)
					{
						if (Popup_OnFlag.brake_to_start)
						{
							Popup_Request(POPUP_ID_brake_to_start);
							Popup_OnFlag.brake_to_start = 0;
						}
					}
					else
					{
						Popup_Delete(POPUP_ID_brake_to_start);
					}
				}
			}
			else
			{
				Popup_Clear(POPUP_ID_brake_to_start);
			}
		}
		else
		{
			if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_Indication_press_brake_clutch() == 1)
			{
				if (Popup_OnFlag.brake_to_start)
				{
					Popup_Request(POPUP_ID_brake_to_start);
					Popup_OnFlag.brake_to_start = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_brake_to_start);
			}
		}
	}
	else
	{
		Popup_Delete(POPUP_ID_brake_to_start);
	}

	// n������
	if (Val_EOL_F110_PEPS() == 1)
	{
		if (SYS_OPR_STAT_IGN_ON)
		{
			if(Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 0)
			{
				if (PageInfo.u16SelfCheckTimeCnt < SelfCheckTime)
				{
					Popup_Delete(POPUP_ID_N_gear_start);
				}
				else
				{
					if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_Indication_shift_to_PN() == 1)
					{
						if (Popup_OnFlag.N_gear_start)
						{
							Popup_Request(POPUP_ID_N_gear_start);
							Popup_OnFlag.N_gear_start = 0;
						}
					}
					else
					{
						Popup_Delete(POPUP_ID_N_gear_start);
					}
				}
			}
			else
			{
				Popup_Clear(POPUP_ID_N_gear_start);
			}
		}
		else
		{
			if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_Indication_shift_to_PN() == 1)
			{
				if (Popup_OnFlag.N_gear_start)
				{
					Popup_Request(POPUP_ID_N_gear_start);
					Popup_OnFlag.N_gear_start = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_N_gear_start);
			}
		}
	}
	else
	{
		Popup_Delete(POPUP_ID_N_gear_start);
	}

	// n��פ��
	if (Val_EOL_F110_PEPS() == 1)
	{
		if (SYS_OPR_STAT_IGN_ON)
		{
			if(Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 0)
			{
				if (PageInfo.u16SelfCheckTimeCnt < SelfCheckTime)
				{
					Popup_Delete(POPUP_ID_N_gear_parking);
				}
				else
				{
					if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_Indication_shift_to_Park() == 1)
					{
						if (Popup_OnFlag.N_gear_parking)
						{
							Popup_Request(POPUP_ID_N_gear_parking);
							Popup_OnFlag.N_gear_parking = 0;
						}
					}
					else
					{
						Popup_Delete(POPUP_ID_N_gear_parking);
					}
				}
			}
			else
			{
				Popup_Clear(POPUP_ID_N_gear_parking);
			}
		}
		else
		{
			if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_Indication_shift_to_Park() == 1)
			{
				if (Popup_OnFlag.N_gear_parking)
				{
					Popup_Request(POPUP_ID_N_gear_parking);
					Popup_OnFlag.N_gear_parking = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_N_gear_parking);
			}
		}
	}
	else
	{
		Popup_Delete(POPUP_ID_N_gear_parking);
	}

	// ����Կ�׵�����
	if (Val_EOL_F110_PEPS() == 1)
	{
		if (SYS_OPR_STAT_IGN_ON)
		{
			if(Get_CAN_CH0_ID_18FF639F_Sig_TBOX_OTA_Mode() == 0)
			{
				if (PageInfo.u16SelfCheckTimeCnt < SelfCheckTime)
				{
					Popup_Delete(POPUP_ID_key_low_power);
				}
				else
				{
					if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_Warn_UID_LOW_BATT() == 1)
					{
						if (Popup_OnFlag.key_low_power)
						{
							Popup_Request(POPUP_ID_key_low_power);
							Popup_OnFlag.key_low_power = 0;
						}
					}
					else
					{
						Popup_Delete(POPUP_ID_key_low_power);
					}
				}
			}
			else
			{
				Popup_Clear(POPUP_ID_key_low_power);
			}
		}
		else
		{
			if (Get_CAN_CH0_ID_18FF0BDF_Sig_PEPS_Warn_UID_LOW_BATT() == 1)
			{
				if (Popup_OnFlag.key_low_power)
				{
					Popup_Request(POPUP_ID_key_low_power);
					Popup_OnFlag.key_low_power = 0;
				}
			}
			else
			{
				Popup_Delete(POPUP_ID_key_low_power);
			}
		}
	}
	else
	{
		Popup_Delete(POPUP_ID_key_low_power);
	}
}
